
struct fat_info_t
{
  int type;
  int cluster_size;
  long offset_to_fat;
  long offset_to_data;
};

struct boot_sector_t
{
  unsigned char jump_instr[3];
  char oem_name[9];
  int bytes_per_sector;
  int sectors_per_cluster;
  int reserved_sector_count;
  int num_alloc_tables;
  int max_root_dir_entries;
  int total_sectors;
  unsigned char media_descriptor;
  int sectors_per_table;
  int sectors_per_track;
  int number_heads;
  int hidden_sectors;
  int total_sectors_4;

  /* Extended BIOS Param Block */

  unsigned char physical_drive_num;
  unsigned char reserved;
  unsigned char signature;
  unsigned char serial_num[5];
  char volume_label[12];
  char file_sys_type[9];
  unsigned char os_boot_code[448];
  unsigned char end_of_sector_marker[2];
};

struct dir_info_t
{
  char dos_name[9];
  char dos_ext[4];
  unsigned char attributes;
  unsigned char reserved;
  char create_time_res;
  int create_time;
  int create_date;
  int access_time;
  int access_date;
  int modified_time;
  int modified_date;
  int first_cluster;
  unsigned int file_size;
  unsigned char vfat_name[256];
  int vfat_name_len;
};

int parse_boot_sector(FILE *in, struct boot_sector_t *boot_sector);
void print_boot_sector(struct boot_sector_t *boot_sector);

int parse_dir(FILE *in, long offset, long partition_offset);


